
### Constants 
# interferometer name
# Note: no Virgo yet
HANFORD = ('HANFORD', 'LHO', 'H1', 'H')
LIVINGSTON = ('LIVINGSTON', 'LLO', 'L1', 'L')

# default nds server and port number
DEFAULT_NDS_SERVER = 'nds.ligo.caltech.edu'
DEFAULT_PORT_NUMBER = 31200

# default paramter types
DEFAULT_PARAMS_TYPES = {
    'setup': {
        'datadir': str,
        'gps_start': int,
        'duration': int,
        'gps_train_start': int,
        'train_duration': int,
        'sampling_frequency': int,
        'chanslist': str,
        'ifo': str,
    },
    'injection': {
        'datadir': str,
        'outdir': str,
        'trigger_time': int,
        'duration': int,
        'post_trigger_duration': int,
        'waveform_approximant': str,
        'reference_frequency': float,
        'minimum_frequency': float,
        'prior_file': str,
        'source_type': str,
        'optimal_snr': float,
    },
    'training': {
        'datadir': str,
        'datadir_hoft': str,
        'datadir_witnesses': str,
        'outdir': str,
        'aux_groups': (str,),
        'batch_size': int,
        'max_epochs': int,
        'use_gpu': bool,
        'unit': str,
    },
    'cleaning': {
        'datadir': str,
        'datadir_hoft': str,
        'datadir_witnesses': str,
        'outdir': str,
        'kernel': float,
        'stride': float,
        'pad_mode': str,
        'window_type': str,
        'checkpoint': str,
        'save_original': bool,
        'skip_training': bool,
        'use_gpu': bool,
        'unit': str,
    },
    'timeseries': {
        'series_type': str,
        'train_kernel': float,
        'train_stride': float,
        'target_kernel': float,
        'target_stride': float,
        'preprocess': bool,
        'norm': bool,
        'filt': bool,
        'filt_which': str,
        'filt_order': int,
        'filt_fl': float,
        'filt_fh': float,
        'pad_mode': str,
        'unit': str
    },
    'criterion': {
        'fl': (float,),
        'fh': (float,),
        'nperseg': float,
        'noverlap': float,
        'reduction': str,
        'average': str,
        'asd': bool,
        'psd_weight': float,
        'mse_weight': float,
        'unit': str,
    },
    'network': {
        'network': str,
        'filters': (int,),
        'kernels': (int,),
        'strides': (int,),
        'activation': str,
        'norm_layer': bool,
        'skip_connection_type': str,
        'rnn_dims': (int,),
        'linear_dims': (int,),
        'rnn_type': str,
    },
    'optimizer': {
        'optimizer': str,
        'lr': float,
        'lr_decay': float,
        'weight_decay': float,
        'betas':(float,),
        'eps': float,
        'amsgrad': bool,
        'lambd': float, 
        'alpha': float,
        't0': float,
        'momentum': float, 
        'centered': bool,
        'etas': (float,),
        'step_sizes': (float,),
        'dampening': float,
        'nesterov': bool,
    },
    'scheduler': {
        'scheduler': str,
        'milestones': (int, ),
        'step_size': int,
        'gamma': float,
        'last_epoch': int,
        'mode': str, 
        'factor': float, 
        'patience': int, 
        'verbose': bool, 
        'threshold': float, 
        'threshold_mode': str, 
        'cooldown': int, 
        'min_lr': float, 
        'eps': float,
    },
    'weight_initializer': {
        'initializer': str,
        'a': float,
        'b': float,
        'mean': float,
        'std': float,
        'val': float,
        'gain': float,
        'mode': str,
        'nonlinearity': str
    }
}
DEFAULT_PARAMS_TYPES['bias_initializer'] = DEFAULT_PARAMS_TYPES['weight_initializer']

# default parameters
DEFAULT_PARAMS = {
    'setup': {
        'sampling_frequency': 1024,
        'chanslist': './chanslist.ini',
        'ifo': 'H1',
    },
    'injection': {
        'duration': 4,
        'post_trigger_duration': 2,
        'waveform_approximant': 'IMRPhenomPv2',
        'source_type': 'BBH',
        'minimum_frequency': 20,
        'reference_frequency': 50,

    },
    'training': {
        'outdir': './training_output',
        'batch_size': 32,
        'max_epochs': 10,
        'use_gpu': True,
    },
    'cleaning': {
        'outdir': './training_output',
        'kernel': 8,
        'stride': 8,
        'window_type': 'rectangular',
        'use_gpu': True,
        'save_original': True,
        'skip_training': False,
        'unit': 'sec',

    },
    'timeseries': {
        'series_type': 'TimeSeriesCNN',
        'train_kernel': 8,
        'train_stride': 1,
        'target_kernel': 8,
        'target_stride': 8,
        'preprocess': True,
        'norm': True,
        'filt': False,
        'filt_which': 'hoft',
        'filt_order': 8,
        'pad_mode': 'mean',
        'unit': 'sec',
    },
    'criterion': {
        'fl': (20, ),
        'fh': (1000, ),
        'nperseg': 256,
        'asd': True,
        'reduction': 'mean',
        'average': 'mean',
        'unit': 'sec',
    },
    'optimizer': {},
    'scheduler': {},
    'network': {},
    'weight_initializer': {},
    'bias_initializer': {},
}